import utilities

#
#
#
class AnimatedSprite16:
	#
	#
	#
	def __init__(self, newPixelPosition, newSpriteNrs, newSpriteAnimationFrameHold, doAnimate = True):
		self.position = [newPixelPosition[0], newPixelPosition[1]]
		self.spriteNrs = newSpriteNrs
		self.spriteAnimationFrameHold = newSpriteAnimationFrameHold
		self.playAnimation = doAnimate
		
		self.resetAnimation()
					
		self.buildAnimationSourceRects()
	
	#
	#
	#	
	def update(self):
		if self.playAnimation == False:
			return
		
		self.spriteAnimationCounter += 1 
		if self.spriteAnimationCounter >= self.spriteAnimationFrameHold:
			self.spriteAnimationCounter = 0	
			
			self.spriteAnimationFrameNr += 1 
			if self.spriteAnimationFrameNr >= len(self.spriteNrs):
				self.spriteAnimationFrameNr = 0 

	#
	#
	#
	def render(self):
		utilities.blitSprite16ToDisplaySurface((self.position[0], self.position[1]), self.spriteSourceRects[self.spriteAnimationFrameNr])
	
	#
	#
	#	
	def buildAnimationSourceRects(self):
		self.spriteSourceRects = []
		
		for spriteNr in self.spriteNrs:
			sourceRect = utilities.calcSourceRectFromSprite16Nr(spriteNr)
			self.spriteSourceRects.append(sourceRect)
	
	#
	#
	#		
	def getPosition(self):
		return (self.position[0], self.position[1])
	
	#
	#
	#		
	def setPosition(self, pixelX, pixelY):
		self.position = [pixelX, pixelY]
	
	#
	#
	#	
	def getFrameNr(self):
		return self.spriteAnimationFrameNr	
	
	#
	#
	#	
	def setFrameNr(self, frameNr):
		self.spriteAnimationFrameNr = frameNr	
	
	#
	#
	#	
	def getAnimationState(self):
		return self.playAnimation
	
	#
	#
	#	
	def setAnimationState(self, doAnimate):
		self.playAnimation = doAnimate

	#
	#
	#	
	def resetAnimation(self):
		self.spriteAnimationCounter = 0
		self.spriteAnimationFrameNr = 0
