import pygame

class SoundFxManager:
	def __init__(self):
		self.doPlay = False
				
		self.channels = []
		for index in range(0, pygame.mixer.get_num_channels() - 1):
			newChannel = pygame.mixer.Channel(index)
			#newChannel.set_volume(0.9)
			#newChannel.unpause()
			self.channels.append(newChannel)
		
		self.SFX_EXPLOSION = 0
		self.SFX_HIT_HARD = 1
		self.SFX_HURRAY = 2
		self.SFX_LOADING_NEXT_LEVEL = 3
		self.SFX_LEVEL_COMPLETE = 4
		self.SFX_OH_NO = 5
		self.SFX_SHOT_A = 6
		self.SFX_STAR_PICKUP_V3 = 7
		self.SFX_THX_HERO = 8
		self.SFX_YAY = 9
		self.SFX_YIHA = 10
		self.SFX_SHOT_B = 11
		self.SFX_TURRET_SHOT = 12
		self.SFX_BUTTON_CLICK = 13
		self.SFX_BUTTON_PUSH = 14
		self.SFX_BOUNCE = 15
		self.SFX_JUMP = 16
		
		self.sfxList = [
			('VanSangsPain/soundfx/explosion.ogg', 0.2),
			('VanSangsPain/soundfx/hithard.ogg', 0.2),	
			('VanSangsPain/soundfx/hurray.ogg',	0.9),
			('VanSangsPain/soundfx/loading_next_level.ogg',	0.9),	
			('VanSangsPain/soundfx/lvl_complete.ogg', 0.9),	
			('VanSangsPain/soundfx/ohno.ogg', 0.9),		
			('VanSangsPain/soundfx/shotA.ogg', 0.9),	
			('VanSangsPain/soundfx/starPickupV3.ogg', 0.9),	
			('VanSangsPain/soundfx/thxhero.ogg', 0.9),	
			('VanSangsPain/soundfx/yay.ogg', 0.9),	
			('VanSangsPain/soundfx/yiha.ogg', 0.9),
			('VanSangsPain/soundfx/shotB.ogg', 0.9),
			('VanSangsPain/soundfx/TurretShot.ogg',	0.8),
			('VanSangsPain/soundfx/Click2-Sebastian-759472264.wav',	0.9),
			('VanSangsPain/soundfx/Button_Push-Mike_Koenig-1659525069.ogg',	0.9),
			('VanSangsPain/soundfx/Bounce-SoundBible.ogg', 0.9),
			('VanSangsPain/soundfx/Jump-SoundBible.ogg', 0.75)
		]
		
		self.loadedSfx = []
		for compound in self.sfxList:
			loadedSoundFx = pygame.mixer.Sound(compound[0])
			loadedSoundFx.set_volume(compound[1])
			self.loadedSfx.append(loadedSoundFx)
		
		self.loadSettings()

	def update(self):		
		pass
						
	def getPlaySoundFx(self):
		return self.doPlay
			
	def playSoundFx(self, flag):
		#print("SoundFxManager.playSoundFx: " + str(flag))
		self.doPlay = flag

	def loadSettings(self):
		f = file('VanSangsPain/soundfx_setting.txt', 'r')		
		lines = f.read().splitlines()
		
		if (lines[0] == '1'):
			self.doPlay = True
		else:
			self.doPlay = False	
			
		#print("Load soundfx setting: " + lines[0])
		
	def saveSettings(self):
		f = open("VanSangsPain/soundfx_setting.txt", 'w')		

		if self.doPlay == True:
			f.write('1')
			#print("Save soundfx setting: 1")
		else:
			f.write('0')
			#print("Save soundfx setting: 0")
						
		f.close()	

	def emitSoundEffect(self, sfxIndex, channelIndex):
		if self.doPlay == False:
			return
		
		if channelIndex >= pygame.mixer.get_num_channels():
			channelIndex = pygame.mixer.get_num_channels() - 1
				
		self.channels[channelIndex].play(self.loadedSfx[sfxIndex], 0, 0, 0)